Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 4901)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1)
@@ -1,160 +1,141 @@
-!> @file check_parameters.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE check_parameters
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! number of allowed profiles increased from 400 to 500
-!
-! 4853 2021-01-25 07:56:09Z raasch
-! number of allowed profiles increased from 300 to 400
-!
-! 4844 2021-01-18 09:22:26Z raasch
-! size check for profile output added
-!
-! 4828 2021-01-05 11:21:41Z Giersch
-! allow prescribing initial uv_profiles AND geostrophic wind
-! by changing error message PA0347 to an informative message
-!
-! 4685 2020-09-18 11:49:50Z gronemeier
-! filter data_output_pr and data_output list for duplicate entries
-!
-! 4633 2020-08-05 14:21:14Z suehring
-! todo added
-!
-! 4565 2020-06-15 08:30:38Z oliver.maas
-! added check for pt_surface_heating_rate
-!
-! 4564 2020-06-12 14:03:36Z raasch
-! Vertical nesting method of Huq et al. (2019) removed
-!
-! 4562 2020-06-12 08:38:47Z raasch
-! bugfix: revised error message for exceeding allow number of time series
-!
-! 4559 2020-06-11 08:51:48Z raasch
-! file re-formatted to follow the PALM coding standard
-!
-! 4536 2020-05-17 17:24:13Z raasch
-! unneccessary query for restart data format removed
-!
-! 4534 2020-05-14 18:35:22Z raasch
-! adjustments for I/O on reduced number of cores using shared memory MPI
-!
-! 4514 2020-04-30 16:29:59Z suehring
-! Enable output of qsurf and ssurf
-!
-! 4513 2020-04-30 13:45:47Z raasch
-! unused modules removed
-!
-! 4511 2020-04-30 12:20:40Z raasch
-! call of chem_boundary_conds removed (respective settings are now done in the chemistry module)
-!
-! 4495 2020-04-13 20:11:20Z raasch
-! check new restart_data_format parameters
-!
-! 4493 2020-04-10 09:49:43Z pavelkrc
-! Kolmogorov length scale eta added to profile output
-!
-! 4444 2020-03-05 15:59:50Z raasch
-! bugfix: cpp-directives for serial mode added
-!
-! 4392 2020-01-31 16:14:57Z pavelkrc
-! Some error numbers revised to prevent double usage
-!
-! 11:55:33Z oliver.maas
-! Checks for closed channel flow implemented
-!
-! 11:55:33Z oliver.maas
-! Move 2-m potential temperature output to diagnostic_output_quantities
-!
-! 11:55:33Z oliver.maas
-! removed message PA0421, concerning old parameter recycling_yshift
-!
-! 11:55:33Z oliver.maas
-! adjust message to the modified parameter recycling_yshift
-!
-! 11:55:33Z oliver.maas
-! Check if a cross section is specified if any output cross-section quantity
-! is given
-!
-! 11:55:33Z oliver.maas
-! Overwrite rotation_angle from namelist by value from static driver
-!
-! 11:55:33Z oliver.maas
-! removed conversion from recycle_absolute_quantities to raq, added check and
-! error message for correct input of recycling_method_for_thermodynamic_quantities
-!
-! 11:55:33Z oliver.maas
-! Corrected "Former revisions" section
-!
-! 11:55:33Z oliver.maas
-! bugfix error message: replaced PA184 by PA0184
-!
-! 11:55:33Z oliver.maas
-! added conversion from recycle_absolute_quantities to raq for recycling of
-! absolute quantities and added error message PA184 for not implemented quantities
-!
-! 4142 2019-08-05 12:38:31Z suehring
-! Consider spinup in number of output timesteps for averaged 2D output (merge
-! from branch resler).
-!
-! 4069 2019-07-01 14:05:51Z Giersch
-! Masked output running index mid has been introduced as a local variable to
-! avoid runtime error (Loop variable has been modified) in time_integration
-!
-! 4048 2019-06-21 21:00:21Z knoop
-! Moved tcm_check_data_output to module_interface
-!
-! 4039 2019-06-18 10:32:41Z suehring
-! Modularize diagnostic output
-!
-! 4017 2019-06-06 12:16:46Z schwenkel
-! output of turbulence intensity added
-!
-! 3933 2019-04-25 12:33:20Z kanani
-! Alphabetical resorting in CASE, condense settings for theta_2m* into one IF clause
-!
-! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction
-! of additional debug messages
-!
-! 3766 2019-02-26 16:23:41Z raasch
-! trim added to avoid truncation compiler warnings
-!
-! 3761 2019-02-25 15:31:42Z raasch
-! unused variables removed
-!
-! 3735 2019-02-12 09:52:40Z dom_dwd_user
-! Passing variable j (averaged output?) to
-! module_interface.f90:chem_check_data_output.
-!
-! 3705 2019-01-29 19:56:39Z suehring
-! bugfix: renamed thetav_t to vtheta_t
-!
-! 3702 2019-01-28 13:19:30Z gronemeier
-! most_method removed
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! Formatting
-!
+! $Log: check_parameters.f90,v $
+! Revision 1.61  2006/08/04 14:20:25  raasch
+! do2d_unit and do3d_unit now defined as 2d-arrays, check of
+! use_upstream_for_tke, default value for dt_dopts,
+! generation of file header moved from routines palm and header to here
+!
+! Revision 1.60  2006/06/02 15:09:15  raasch
+! data_output_xy/xz/yz are set
+!
+! Revision 1.59  2006/03/03 15:55:34  letzel
+! Spelling inconsistency removed
+!
+! Revision 1.58  2006/03/03 08:50:08  raasch
+! Default setting of constant_heatflux now only depends on the value of
+! surface_heatflux again
+!
+! Revision 1.57  2006/02/27 10:16:44  letzel
+! Error removed in initialization of dt_averaging_input_pr
+!
+! Revision 1.56  2006/02/23 10:06:55  raasch
+! Volume flow conservation is not allowed with non-cyclic lateral boundaries,
+! calculation of nzb_diff moved to init_grid, the default setting of
+! constant_heatflux = .F. additionally requires a surface initial temperature
+! change /= 0, check of topography, dissipation_1d, mixing_length_1d,
+! check and setting of new data output steering parameters and user defined
+! output quantities,
+! ebene renamed section, pl1d_anz, plts_anz renamed dopr_n, dots_n,
+! plts, pl1d renamed data_output_ts/1d
+!
+! Revision 1.55  2005/12/06 16:39:34  raasch
+! Output of ql profile is allowed in case of using cloud droplets
+!
+! Revision 1.54  2005/06/30 11:27:33  steinfeld
+! Initialization of the profiles of the geostrophic wind components
+! ug and vg;
+! the usage of the geostrophic wind in a galilei transformation is
+! not allowed with a simultaneous specification of a baroclinicity
+!
+! Revision 1.53  2005/05/18 15:12:36  raasch
+! Check of data_output_format and netcdf precision,
+! abort if poisfft_hybrid is called in a non-parallel environment
+!
+! Revision 1.52  2005/04/23 09:04:10  raasch
+! fcl_factor renamed cfl_factor, default setting of outflow_damping_width
+! corrected, additional check for non-cyclic lateral boundary conditions
+!
+! Revision 1.51  2005/03/26 19:47:32  raasch
+! Check of bc_lr, bc_ns, km_damp_max, inflow_disturbance_begin,
+! inflow_disturbance_end, outflow_damping_width
+!
+! Revision 1.50  2004/04/30 11:20:27  raasch
+! Check of grid_matching, check of time series profiles modified,
+! impulse_advec renamed momentum_advec
+!
+! Revision 1.49  2004/01/28 15:04:56  raasch
+! Additional checks and settings for timestep schemes because of the
+! newly implemented Runge-Kutta schemes
+!
+! Revision 1.48  2003/04/17 07:07:43  raasch
+! Hybrid solver check in parallel environment only
+!
+! Revision 1.47  2003/04/16 09:43:20  raasch
+! Additional checks for hybrid solver and host, Monin Obukhov length added to
+! time series
+!
+! Revision 1.46  2003/03/31 15:43:19  raasch
+! Check for horizontal temperature flux profiles cleaned up
+!
+! Revision 1.45  2003/03/14 13:38:02  raasch
+! Random generator check included
+!
+! Revision 1.44  2003/03/12 16:23:10  raasch
+! Small checks for NEC and temperton-algorithm
+!
+! Revision 1.43  2002/12/19 14:04:26  raasch
+! Setting default values for termination_time_needed and check the
+! value for IBM-regatta, STOP statement replaced by call of subroutine
+! local_stop
+!
+! Revision 1.42  2002/09/12 13:02:25  raasch
+! Error in calculating initial pt and q profiles removed (array bound 10 in
+! *_ind arrays could be exceeded)
+!
+! Revision 1.41  2002/06/11 12:49:33  raasch
+! Hybrid solver allowed for solving the Poisson equation
+!
+! Revision 1.40  2002/05/02  18:48:56  18:48:56  raasch (Siegfried Raasch)
+! SELECT case of cross_normalized_x and ..y requires usage of TRIM-function
+! on IBM
+! 
+! Revision 1.39  2002/04/16 08:03:27  raasch
+! Parameters for scalar transport included, output of scalar profiles changed
+!
+! Revision 1.38  2001/11/28 09:48:32  schroeter
+! Profiles for horizontal heat fluxes and
+! flux divergences allowed (58-72)
+!
+! Revision 1.37  2001/09/04  11:58:55  11:58:55  raasch (Siegfried Raasch)
+! Profiles for vertical flux of resolved/subgrid scale energy and pressure
+! fluctuations allowed (#55-57)
+! 
+! Revision 1.36  2001/07/20 12:52:32  raasch
+! Multigrid method allowed for solving the Poisson equation
+!
+! Revision 1.35  2001/03/30 06:57:38  raasch
+! Asselin filter factor is set to 0, if Euler scheme is used,
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.34  2001/02/09 07:04:45  raasch
+! Checking of boundary conditions for pt and q and their combination with
+! prescribed surface fluxes revised
+!
+! Revision 1.33  2001/01/29 12:23:31  raasch
+! New parameter passive_scalar is checked
+!
+! Revision 1.32  2001/01/25 06:55:37  raasch
+! New control-parameters fft_method and use_surface_fluxes are checked
+!
+! Revision 1.31  2000/04/18 11:19:43  schroeter
+! Bott-Chlond Advektionsschema nun auch fuer Rechnungen
+! mit Feuchte/Wolkenphysik zugelassen
+!
+! Revision 1.30  2000/04/13 13:28:56  schroeter
+! + initialize profiles of total water content
+! + check boundary conditions of total water content
+! + initialize output of cloud-physics-profiles
+!
+! Revision 1.29  2000/01/25  14:38:37  14:38:37  letzel (Marcus Letzel)
+! All comments translated into English
+! 
 ! Revision 1.1  1997/08/26 06:29:23  raasch
 ! Initial revision
@@ -163,373 +144,55 @@
 ! Description:
 ! ------------
-!> Check control parameters and deduce further quantities.
-!
-!> @todo Increase character length of unit and corresponding characters to LEN>=8 in order to allow
-!>       units like degree_C (05.08.2020)
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE check_parameters
-
+! Check control parameters and deduce further quantities.
+!------------------------------------------------------------------------------!
 
     USE arrays_3d
-
-    USE basic_constants_and_equations_mod
-
-    USE bulk_cloud_model_mod,                                                                      &
-        ONLY:  bulk_cloud_model
-
+    USE constants
     USE control_parameters
-
     USE grid_variables
-
-    USE kinds
-
     USE indices
-
-    USE model_1d_mod,                                                                              &
-        ONLY:  damp_level_1d, damp_level_ind_1d
-
-    USE module_interface,                                                                          &
-        ONLY:  module_interface_check_data_output,                                                 &
-               module_interface_check_data_output_pr,                                              &
-               module_interface_check_data_output_ts,                                              &
-               module_interface_check_parameters
-
-    USE netcdf_data_input_mod,                                                                     &
-        ONLY:  init_model, input_pids_static, netcdf_data_input_check_dynamic,                     &
-               netcdf_data_input_check_static
-
-    USE netcdf_interface,                                                                          &
-        ONLY:  do2d_unit, do3d_unit, dopr_unit, dots_label, dots_max, dots_num, dots_unit,         &
-               heatflux_output_unit, momentumflux_output_unit, netcdf_data_format,                 &
-               netcdf_data_format_string, waterflux_output_unit
-
-    USE particle_attributes,                                                                       &
-        ONLY:  particle_advection, use_sgs_for_particles
-
+    USE model_1d
+    USE netcdf_control
+    USE particle_attributes
     USE pegrid
-
-    USE pmc_interface,                                                                             &
-        ONLY:  cpl_id, nested_run
-
     USE profil_parameter
-
     USE statistics
-
-    USE subsidence_mod
-
     USE transpose_indices
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=varnamelength)  ::  var           !< variable name
-    CHARACTER (LEN=7)   ::  unit                     !< unit of variable
-    CHARACTER (LEN=8)   ::  date                     !< current date string
-    CHARACTER (LEN=10)  ::  time                     !< current time string
-    CHARACTER (LEN=20)  ::  ensemble_string          !< string containing number of ensemble member
-    CHARACTER (LEN=15)  ::  nest_string              !< string containing id of nested domain
-    CHARACTER (LEN=40)  ::  coupling_string          !< string containing type of coupling
-    CHARACTER (LEN=100) ::  action                   !< flag string
-
-    CHARACTER (LEN=varnamelength), DIMENSION(:), ALLOCATABLE ::  data_output_filtered  !< filtered list of output variables
-
-    INTEGER(iwp) ::  i                               !< loop index
-    INTEGER(iwp) ::  ilen                            !< string length
-    INTEGER(iwp) ::  j                               !< loop index
-    INTEGER(iwp) ::  k                               !< loop index
-    INTEGER(iwp) ::  kk                              !< loop index
-    INTEGER(iwp) ::  mid                             !< masked output running index
-    INTEGER(iwp) ::  netcdf_data_format_save         !< initial value of netcdf_data_format
-    INTEGER(iwp) ::  position                        !< index position of string
-
-    LOGICAL     ::  found                            !< flag, true if output variable is already marked for averaging
-
-    REAL(wp)    ::  gradient                         !< local gradient
-#if defined( __parallel )
-    REAL(wp)    ::  dt_spinup_max                    !< maximum spinup timestep in nested domains
-    REAL(wp)    ::  remote = 0.0_wp                  !< MPI id of remote processor
-    REAL(wp)    ::  spinup_time_max                  !< maximum spinup time in nested domains
-    REAL(wp)    ::  time_to_be_simulated_from_reference_point  !< time to be simulated from reference point
-#endif
-
-
-    CALL location_message( 'checking parameters', 'start' )
-!
-!-- At first, check static and dynamic input for consistency.
-    CALL netcdf_data_input_check_dynamic
-    CALL netcdf_data_input_check_static
-!
-!-- Check for overlap combinations, which are not realized yet
-    IF ( transpose_compute_overlap  .AND. numprocs == 1 )  THEN
-          message_string = 'transpose-compute-overlap not implemented for single PE runs'
-          CALL message( 'check_parameters', 'PA0000', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check the coupling mode
-    IF ( coupling_mode /= 'uncoupled'            .AND.                                             &
-         coupling_mode /= 'precursor_atmos'      .AND.                                             &
-         coupling_mode /= 'precursor_ocean'      .AND.                                             &
-         coupling_mode /= 'atmosphere_to_ocean'  .AND.                                             &
-         coupling_mode /= 'ocean_to_atmosphere' )  THEN
-       message_string = 'illegal coupling mode: ' // TRIM( coupling_mode )
-       CALL message( 'check_parameters', 'PA0002', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check if humidity is set to .TRUE. in case of the atmospheric run (for coupled runs)
-    IF ( coupling_mode == 'atmosphere_to_ocean' .AND. .NOT. humidity) THEN
-       message_string = ' Humidity has to be set to .T. in the _p3d file ' //                      &
-                        'for coupled runs between ocean and atmosphere.'
-       CALL message( 'check_parameters', 'PA0476', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Check and set the restart data format variables
-    IF ( TRIM( restart_data_format ) /= 'fortran_binary'  .AND.                                    &
-         TRIM( restart_data_format ) /= 'mpi'             .AND.                                    &
-         TRIM( restart_data_format ) /= 'mpi_shared_memory' )  THEN
-       message_string = 'illegal restart data format "' // TRIM( restart_data_format ) // '"'
-       CALL message( 'check_parameters', 'PA0724', 1, 2, 0, 6, 0 )
-    ENDIF
-
-    IF ( TRIM( restart_data_format_input ) == 'undefined' )  THEN
-       restart_data_format_input = restart_data_format
-    ENDIF
-    IF ( TRIM( restart_data_format_output ) == 'undefined' )  THEN
-       restart_data_format_output = restart_data_format
-    ENDIF
-
-    IF ( TRIM( restart_data_format_input ) /= 'fortran_binary'  .AND.                              &
-         TRIM( restart_data_format_input ) /= 'mpi'             .AND.                              &
-         TRIM( restart_data_format_input ) /= 'mpi_shared_memory' )  THEN
-       message_string = 'illegal restart input data format "' //                                   &
-                        TRIM( restart_data_format_input ) // '"'
-       CALL message( 'check_parameters', 'PA0725', 1, 2, 0, 6, 0 )
-    ENDIF
-    IF ( TRIM( restart_data_format_output ) /= 'fortran_binary'  .AND.                             &
-         TRIM( restart_data_format_output ) /= 'mpi'             .AND.                             &
-         TRIM( restart_data_format_output ) /= 'mpi_shared_memory' )  THEN
-       message_string = 'illegal restart output data format "' //                                  &
-                        TRIM( restart_data_format_output ) // '"'
-       CALL message( 'check_parameters', 'PA0726', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Set flag for including total domain boundaries in the restart data (MPI-IO) in case of
-!-- non-cyclic boundary conditions
-    include_total_domain_boundaries = .NOT. ( bc_lr_cyc  .AND.  bc_ns_cyc )
-
-!
-!-- Check dt_coupling, restart_time, dt_restart, end_time, dx, dy, nx and ny
-    IF ( coupling_mode /= 'uncoupled'        .AND.                                                 &
-         coupling_mode /= 'precursor_atmos'  .AND.                                                 &
-         coupling_mode /= 'precursor_ocean' )  THEN
-
-       IF ( dt_coupling == 9999999.9_wp )  THEN
-          message_string = 'dt_coupling is not set but required for coupling mode "' //            &
-                           TRIM( coupling_mode ) // '"'
-          CALL message( 'check_parameters', 'PA0003', 1, 2, 0, 6, 0 )
-       ENDIF
-
-#if defined( __parallel )
-
-
-       IF ( myid == 0 ) THEN
-          CALL MPI_SEND( dt_coupling, 1, MPI_REAL, target_id, 11, comm_inter, ierr )
-          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 11, comm_inter, status, ierr )
-       ENDIF
-       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
-
-       IF ( dt_coupling /= remote )  THEN
-          WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), '": dt_coupling = ',&
-                 dt_coupling, '& is not equal to ', 'dt_coupling_remote = ', remote
-          CALL message( 'check_parameters', 'PA0004', 1, 2, 0, 6, 0 )
-       ENDIF
-       IF ( dt_coupling <= 0.0_wp )  THEN
-
-          IF ( myid == 0  ) THEN
-             CALL MPI_SEND( dt_max, 1, MPI_REAL, target_id, 19, comm_inter, ierr )
-             CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 19, comm_inter, status, ierr )
-          ENDIF
-          CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
-
-          dt_coupling = MAX( dt_max, remote )
-          WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ),                     &
-                 '": dt_coupling <= 0.0 & is not allowed and is reset to ', 'MAX(dt_max(A,O)) = ', &
-                 dt_coupling
-          CALL message( 'check_parameters', 'PA0005', 0, 1, 0, 6, 0 )
-       ENDIF
-
-       IF ( myid == 0 ) THEN
-          CALL MPI_SEND( restart_time, 1, MPI_REAL, target_id, 12, comm_inter, ierr )
-          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 12, comm_inter, status, ierr )
-       ENDIF
-       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
-
-       IF ( restart_time /= remote )  THEN
-          WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ),                     &
-                 '": restart_time = ', restart_time, '& is not equal to ',                         &
-                 'restart_time_remote = ', remote
-          CALL message( 'check_parameters', 'PA0006', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( myid == 0 ) THEN
-          CALL MPI_SEND( dt_restart, 1, MPI_REAL, target_id, 13, comm_inter, ierr )
-          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 13, comm_inter, status, ierr )
-       ENDIF
-       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
-
-       IF ( dt_restart /= remote )  THEN
-          WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ), '": dt_restart = ', &
-                 dt_restart, '& is not equal to ', 'dt_restart_remote = ', remote
-          CALL message( 'check_parameters', 'PA0007', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       time_to_be_simulated_from_reference_point = end_time-coupling_start_time
-
-       IF ( myid == 0 ) THEN
-          CALL MPI_SEND( time_to_be_simulated_from_reference_point, 1, MPI_REAL, target_id, 14,    &
-                         comm_inter, ierr )
-          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 14, comm_inter, status, ierr )
-       ENDIF
-       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
-
-       IF ( time_to_be_simulated_from_reference_point /= remote )  THEN
-          WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ),                     &
-                 '": time_to_be_simulated_from_reference_point = ',                                &
-                 time_to_be_simulated_from_reference_point, '& is not equal ',                     &
-                 'to time_to_be_simulated_from_reference_point_remote = ',                         &
-                 remote
-          CALL message( 'check_parameters', 'PA0008', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( myid == 0 ) THEN
-          CALL MPI_SEND( dx, 1, MPI_REAL, target_id, 15, comm_inter, ierr )
-          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 15, comm_inter, status, ierr )
-       ENDIF
-       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
-
-
-       IF ( coupling_mode == 'atmosphere_to_ocean') THEN
-
-          IF ( dx < remote ) THEN
-             WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ),                  &
-                    '": dx in Atmosphere is not equal to or not larger than dx in ocean'
-             CALL message( 'check_parameters', 'PA0009', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( (nx_a+1)*dx /= (nx_o+1)*remote )  THEN
-             WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ),                  &
-                    '": Domain size in x-direction is not equal in ocean and atmosphere'
-             CALL message( 'check_parameters', 'PA0010', 1, 2, 0, 6, 0 )
-          ENDIF
-
-       ENDIF
-
-       IF ( myid == 0) THEN
-          CALL MPI_SEND( dy, 1, MPI_REAL, target_id, 16, comm_inter, ierr )
-          CALL MPI_RECV( remote, 1, MPI_REAL, target_id, 16, comm_inter, status, ierr )
-       ENDIF
-       CALL MPI_BCAST( remote, 1, MPI_REAL, 0, comm2d, ierr)
-
-       IF ( coupling_mode == 'atmosphere_to_ocean') THEN
-
-          IF ( dy < remote )  THEN
-             WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ),                  &
-                    '": dy in Atmosphere is not equal to or not larger than dy in ocean'
-             CALL message( 'check_parameters', 'PA0011', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( (ny_a+1)*dy /= (ny_o+1)*remote )  THEN
-             WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ),                  &
-                    '": Domain size in y-direction is not equal in ocean and atmosphere'
-             CALL message( 'check_parameters', 'PA0012', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( MOD( nx_o+1, nx_a+1 ) /= 0 )  THEN
-             WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ),                  &
-                    '": nx+1 in ocean is not divisible by nx+1 in', ' atmosphere without remainder'
-             CALL message( 'check_parameters', 'PA0339', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          IF ( MOD(ny_o+1,ny_a+1) /= 0 )  THEN
-             WRITE( message_string, * ) 'coupling mode "', TRIM( coupling_mode ),                  &
-                    '": ny+1 in ocean is not divisible by ny+1 in', ' atmosphere without remainder'
-
-             CALL message( 'check_parameters', 'PA0340', 1, 2, 0, 6, 0 )
-          ENDIF
-
-       ENDIF
-#else
-       WRITE( message_string, * ) 'coupling requires PALM to be compiled with',                    &
-              ' cpp-option "-D__parallel"'
-       CALL message( 'check_parameters', 'PA0141', 1, 2, 0, 6, 0 )
-#endif
-    ENDIF
-
-#if defined( __parallel )
-!
-!-- Exchange via intercommunicator
-    IF ( coupling_mode == 'atmosphere_to_ocean'  .AND.  myid == 0 )  THEN
-       CALL MPI_SEND( humidity, 1, MPI_LOGICAL, target_id, 19, comm_inter, ierr )
-    ELSEIF ( coupling_mode == 'ocean_to_atmosphere'  .AND.  myid == 0)  THEN
-       CALL MPI_RECV( humidity_remote, 1, MPI_LOGICAL, target_id, 19, comm_inter, status, ierr )
-    ENDIF
-    CALL MPI_BCAST( humidity_remote, 1, MPI_LOGICAL, 0, comm2d, ierr)
-
-#endif
-
-!
-!-- User settings for restart times requires that "restart" has been given as file activation
-!-- string. Otherwise, binary output would not be saved by palmrun.
-    IF ( ( restart_time /= 9999999.9_wp  .OR.  dt_restart /= 9999999.9_wp )                        &
-         .AND.  .NOT. write_binary )  THEN
-       WRITE( message_string, * ) 'manual restart settings requires file ',                        &
-                                  'activation string "restart"'
-       CALL message( 'check_parameters', 'PA0001', 1, 2, 0, 6, 0 )
-    ENDIF
-
-
-!
-!-- Generate the file header which is used as a header for most of PALM's output files
-    CALL DATE_AND_TIME( date, time, run_zone )
-    run_date = date(1:4) // '-' // date(5:6) // '-' // date(7:8)
-    run_time = time(1:2) // ':' // time(3:4) // ':' // time(5:6)
-    IF ( coupling_mode == 'uncoupled' )  THEN
-       coupling_string = ''
-    ELSEIF ( coupling_mode == 'atmosphere_to_ocean' )  THEN
-       coupling_string = ' coupled (atmosphere)'
-    ELSEIF ( coupling_mode == 'ocean_to_atmosphere' )  THEN
-       coupling_string = ' coupled (ocean)'
-    ENDIF
-    IF ( ensemble_member_nr /= 0 )  THEN
-       WRITE( ensemble_string, '(2X,A,I2.2)' )  'en-no: ', ensemble_member_nr
-    ELSE
-       ensemble_string = ''
-    ENDIF
-    IF ( nested_run )  THEN
-       WRITE( nest_string, '(2X,A,I2.2)' )  'nest-id: ', cpl_id
-    ELSE
-       nest_string = ''
-    ENDIF
-
-    WRITE ( run_description_header, '(A,2X,A,2X,A,A,A,I2.2,A,A,A,2X,A,A,2X,A,1X,A)' )              &
-          TRIM( version ), TRIM( revision ), 'run: ', TRIM( run_identifier ), '.', runnr,          &
-          TRIM( coupling_string ), TRIM( nest_string ), TRIM( ensemble_string), 'host: ',          &
-          TRIM( host ), run_date, run_time
-
-!
-!-- Check the general loop optimization method
-    SELECT CASE ( TRIM( loop_optimization ) )
-
-       CASE ( 'cache', 'vector' )
-          CONTINUE
-
-       CASE DEFAULT
-          message_string = 'illegal value given for loop_optimization: "' //                       &
-                           TRIM( loop_optimization ) // '"'
-          CALL message( 'check_parameters', 'PA0013', 1, 2, 0, 6, 0 )
-
-    END SELECT
+    CHARACTER (LEN=1)   ::  sq
+    CHARACTER (LEN=6)   ::  var
+    CHARACTER (LEN=7)   ::  unit
+    CHARACTER (LEN=8)   ::  date
+    CHARACTER (LEN=10)  ::  time
+    CHARACTER (LEN=100) ::  action
+
+    INTEGER ::  i, ilen, intervals, iter, j, k, nnxh, nnyh, position, prec
+    LOGICAL ::  found, ldum
+    REAL    ::  gradient, maxn, maxp
+
+
+!
+!-- Warning, if host is not set
+    IF ( host(1:1) == ' ' )  THEN
+       IF ( myid == 0 )  THEN
+          PRINT*, '+++ WARNING: check_parameters:'
+          PRINT*, '    "host" is not set. Please check that environment', &
+                       ' variable "localhost"'
+          PRINT*, '    is set before running PALM'
+       ENDIF
+    ENDIF
+
+!
+!-- Generate the file header which is used as a header for most of PALM's
+!-- output files
+    CALL DATE_AND_TIME( date, time )
+    run_date = date(7:8)//'-'//date(5:6)//'-'//date(3:4)
+    run_time = time(1:2)//':'//time(3:4)//':'//time(5:6)
+
+    WRITE ( run_description_header, '(A,2X,A,A,A,I2.2,2X,A,A,2X,A,1X,A)' )  &
+              TRIM( version ),'run: ', TRIM( run_identifier ), '.', &
+              runnr, 'host: ', TRIM( host ), run_date, run_time
 
 !
@@ -537,11 +200,11 @@
     IF ( topography /= 'flat' )  THEN
        action = ' '
-       IF ( scalar_advec /= 'pw-scheme'  .AND.  scalar_advec /= 'ws-scheme' )  THEN
+       IF ( scalar_advec /= 'pw-scheme' )  THEN
           WRITE( action, '(A,A)' )  'scalar_advec = ', scalar_advec
        ENDIF
-       IF ( momentum_advec /= 'pw-scheme'  .AND.  momentum_advec /= 'ws-scheme' )  THEN
+       IF ( momentum_advec /= 'pw-scheme' )  THEN
           WRITE( action, '(A,A)' )  'momentum_advec = ', momentum_advec
        ENDIF
-       IF ( psolver == 'sor' )  THEN
+       IF ( psolver == 'multigrid'  .OR.  psolver == 'sor' )  THEN
           WRITE( action, '(A,A)' )  'psolver = ', psolver
        ENDIF
